Index: sandbox/MultiChannelUSB/UserInterface.tcl
===================================================================
--- sandbox/MultiChannelUSB/UserInterface.tcl	(revision 106)
+++ sandbox/MultiChannelUSB/UserInterface.tcl	(revision 143)
@@ -830,8 +951,193 @@
         }
 
-        set val_addr [format %04x [expr {11 + ${number}}]]
-        set value [format %04x $base_val]
-
-        my usbCmd ${val_addr}${value}
+        set val_addr [format %02x [expr {7 + 2 * ${number}}]]
+        set value [format %03x $base_val]
+
+        $controller usbCmd 000200${val_addr}0004${base_typ}${value}
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc rate_val_update {name key op} {
+        my instvar config rate_val
+
+        ${config}.rate_frame.${key}_value configure -text [format {%.2e} $rate_val(${key})]
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_val_update args {
+        my instvar cntr_val cntr_h cntr_m cntr_s
+
+        set cntr_tmp [expr {${cntr_val}/20000}]
+        set cntr_h [expr {${cntr_tmp}/3600000}]
+        set cntr_m [expr {${cntr_tmp}%3600000/60000}]
+        set cntr_s [expr {${cntr_tmp}%3600000%60000/1000.0}]
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_setup {} {
+        my instvar controller number cntr_val
+
+        set word0 [format %08x [expr {${cntr_val} & 0xFFFFFFFF}]]
+        set word1 [format %08x [expr {${cntr_val} >> 32}]]
+
+        set prefix [format %x [expr {5 + ${number}}]]
+
+        set command {}
+        append command 0001${prefix}000000200000004[string range $word0 4 7]
+        append command 0001${prefix}000000200010004[string range $word0 0 3]
+        append command 0001${prefix}000000200020004[string range $word1 4 7]
+        append command 0001${prefix}000000200030004[string range $word1 0 3]
+
+        # send counter value
+        $controller usbCmd $command
+
+        # load counter value
+#        set val_addr [format %02x [expr {12 + ${number}}]]
+#        $controller usbCmd 000200${val_addr}00040001000200${val_addr}00040000
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_reset {} {
+        my instvar controller number after_handle
+        my instvar cntr_val cntr_bak cntr_old yvec_bak yvec_old
+
+        my cntr_stop
+
+        set value [format %04x [expr {1 << (5 + ${number})}]]
+        $controller usbCmd 000200000004${value}0002000000040000
+
+        set cntr_val $cntr_bak
+        my cntr_setup
+
+        set cntr_old $cntr_bak
+        set yvec_bak 0.0
+        set yvec_old 0.0
+        
+        my acquire
+
+        my cntr_ready
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_ready {} {
+        my instvar config cntr_val cntr_bak
+
+        set cntr_val $cntr_bak
+
+        ${config}.start configure -text Start -command [myproc cntr_start]
+        ${config}.reset configure -state active
+
+        ${config}.cntr_frame.h_field configure -state normal
+        ${config}.cntr_frame.m_field configure -state normal
+        ${config}.cntr_frame.s_field configure -state normal
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_start {} {
+        my instvar config
+        my instvar cntr_h cntr_m cntr_s
+        my instvar cntr_val cntr_bak cntr_old yvec_bak yvec_old
+
+        set h $cntr_h
+        set m $cntr_m
+        set s $cntr_s
+
+        if {[string equal $h {}]} {
+            set h 0
+        }
+        if {[string equal $m {}]} {
+            set m 0
+        }
+        if {[string equal $s {}]} {
+            set s 0
+        }
+
+        set cntr_tmp [expr {${h}*3600000 + ${m}*60000 + ${s}*1000}]
+        set cntr_tmp [expr {entier(20000 * ${cntr_tmp})}]
+
+        if {$cntr_tmp > 0} {
+            ${config}.cntr_frame.h_field configure -state disabled
+            ${config}.cntr_frame.m_field configure -state disabled
+            ${config}.cntr_frame.s_field configure -state disabled
+
+            set cntr_val $cntr_tmp
+            set cntr_bak $cntr_tmp
+            set cntr_old $cntr_tmp
+            set yvec_bak [usb::integrateBlt [myvar yvec] 0]
+            set yvec_old $yvec_bak
+
+            my cntr_setup
+
+            my cntr_resume
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_pause {} {
+        my instvar config
+
+        my cntr_stop
+
+        ${config}.start configure -text Resume -command [myproc cntr_resume]
+#        ${config}.reset configure -state active
+
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_resume {} {
+        my instvar controller config number auto
+
+        set val_addr [format %02x [expr {13 + ${number}}]]
+
+        ${config}.start configure -text Pause -command [myproc cntr_pause]
+#        ${config}.reset configure -state disabled
+
+        $controller usbCmd 000200${val_addr}00040002
+
+        set auto 1
+
+        after 100 [myproc acquire_loop]
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc cntr_stop {} {
+        my instvar controller config number auto
+
+        set val_addr [format %02x [expr {13 + ${number}}]]
+
+        $controller usbCmd 000200${val_addr}00040000
+
+        set auto 0
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc data_update args {
+        my instvar data
+        usb::convertBlt $data 4 [myvar yvec]
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc acquire_loop {} {
+        my instvar cntr_val auto
+
+        my acquire
+
+        if {$cntr_val == 0} {
+            my cntr_stop
+            my cntr_ready
+        } elseif {$auto} {
+            after 1000 [myproc acquire_loop]
+        }
     }
 
@@ -839,33 +1145,62 @@
 
     HstDisplay instproc acquire {} {
+        my instvar controller config number
+        my instvar cntr_val cntr_bak cntr_old yvec_bak yvec_old rate_val
+
+        set size 4096
+
+        set prefix [format {%x} [expr {$number + 2}]]
+
+        set value [format {%08x} [expr {$size * 2}]]
+
+        set command 0001${prefix}000000200000001[string range $value 0 3]0003[string range $value 4 7]00050000
+
+        $controller usbCmdReadRaw $command [expr {$size * 4}] [myvar data]
+        set yvec_new [usb::integrateBlt [myvar yvec]]
+
+        set prefix [format {%x} [expr {$number + 5}]]
+        set command 0001${prefix}000000200000003000400050000
+
+        $controller usbCmdReadHex $command 8 1 [myvar cntr_val]
+        set cntr_new $cntr_val
+
+        if {$cntr_new < $cntr_old} {
+            set rate_val(inst) [expr {($yvec_new - $yvec_old)*20000000/($cntr_old - $cntr_new)}]
+            set rate_val(mean) [expr {($yvec_new - $yvec_bak)*20000000/($cntr_bak - $cntr_new)}]
+            set yvec_old $yvec_new
+            set cntr_old $cntr_new
+        }
+   }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc save_data {data} {
         my instvar number
-        my usbCmdRead 0002001${number} 4 4096
-   }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc restart {} {
-        my instvar number
-        my usbCmd 0001001${number}
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc save_data {data} {
-        set file [tk_getSaveFile]
-        if {[string equal $file {}]} {
+
+        set types {
+            {{Data Files}       {.dat}        }
+            {{All Files}        *             }
+        }
+
+        set stamp [clock format [clock seconds] -format %Y%m%d_%H%M%S]
+        set fname spectrum_[expr {$number + 1}]_${stamp}.dat
+
+        set fname [tk_getSaveFile -filetypes $types -initialfile $fname]
+        if {[string equal $fname {}]} {
             return
         }
 
-        set x [catch {set fid [open $file w+]}]
-        set y [catch {puts $fid $data}]
-        set z [catch {close $fid}]
-
-        if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
+        set x [catch {
+            set fid [open $fname w+]
+            puts $fid $data
+            close $fid
+        }]
+
+        if { $x || ![file exists $fname] || ![file isfile $fname] || ![file readable $fname] } {
             tk_messageBox -icon error \
-                -message "An error occurred while writing to \"$file\""
+                -message "An error occurred while writing to \"$fname\""
         } else {
             tk_messageBox -icon info \
-                -message "File \"$file\" written successfully"
+                -message "File \"$fname\" written successfully"
         }
     }
@@ -874,39 +1209,27 @@
 
     HstDisplay instproc register {} {
-        my save_data [my set data]
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc acquire_loop {} {
-        my instvar number after_handle
-
-        my acquire
-
-        set after_handle [after 1000 [myproc acquire_loop]]
-    }
-
-# -------------------------------------------------------------------------
-
-    Class EptDisplay -superclass Display -parameter {
-        {number}
+        my save_data [join [[myvar yvec] range 0 4095] \n]
+    }
+
+# -------------------------------------------------------------------------
+
+    Class CntDisplay -parameter {
         {master}
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc init {} {
-        my instvar data xvec yvec
-
-        set xvec [vector #auto]
-
-        for {set i 0} {$i < 11} {incr i} {
-          set yvec($i) [vector #auto]
-        }
-
-        # fill one vector for the x axis
-        $xvec seq 0 10000
-
-        my reset
+        {controller}
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc init {} {
+
+        my set data {}
+        my set cntr 0
+        my set recs 0
+
+        vector create [myvar xvec](16384)
+        vector create [myvar yvec](16384)
+
+        # fill one vector for the x axis with 16384 points
+        [myvar xvec] seq -0.5 16384.5
 
         my setup
@@ -917,5 +1240,5 @@
 # -------------------------------------------------------------------------
 
-    EptDisplay instproc destroy {} {
+    CntDisplay instproc destroy {} {
         next
     }
